/*				auth.c					*/
/*########################################################################
#                                                                        #
#                            Total IRC Access tunnel                     #
#                    by tHE rECIdjVO <recidjvo@pkcrew.org>               #
#                         http://tiatunnel.pkcrew.org/                   #
#                                                                        #
#   version: 0.9alpha3                                                   #
########################################################################*/

#define WRONG_PROTOCOL "ERROR :Closing link: Password required"
#define WRONG_PASSWD "ERROR :Closing link: Incorrect password"

#include "tiatunnel.h"

extern struct tunnel *t_data;

struct tunnel *auth_conn(int *csock, int entries);

struct tunnel *auth_conn(int *csock, int entries)
{
	char authline[512];
	struct tunnel *t_current;
	int i = 0;

	// Read one line from the client
	bzero(authline, 512);
	while((authline[i - 1] != '\n') && (authline[i - 1] != '\r') && (i < 512)) {
		read(*csock, (authline + i++), (size_t)1);
	}

	// Check for passwd
	authline[strlen(authline) - 1] = '\0';
	if(strncasecmp(authline, "PASS ", (size_t)5) != 0) {
		write(*csock, WRONG_PROTOCOL "\n", (size_t)(strlen(WRONG_PROTOCOL) + 1));
		return(NULL);
	}

	// Check all structures
	for(i = 0; i < entries; i++) {
		t_current = (struct tunnel *)((int)t_data + (i * sizeof(struct tunnel)));
		if(strcmp(authline + 5, t_current->t_passwd) == 0) {
			return(t_current);
		}
	}	

	// No match found
	write(*csock, WRONG_PASSWD "\n", (size_t)(strlen(WRONG_PASSWD) + 1));
	log("Login failed");
	return(NULL);
}

/*				auth.c					*/
