/*				resolv.c				*/
/*########################################################################
#                                                                        #
#                            Total IRC Access tunnel                     #
#                    by tHE rECIdjVO <recidjvo@pkcrew.org>               #
#                         http://tiatunnel.pkcrew.org/                   #
#                                                                        #
#   version: 0.9alpha3                                                   #
########################################################################*/

#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <sys/types.h>
#include "tiatunnel.h"

int resolv4(char *hostname, struct sockaddr_in *saddr);
#ifdef _HAVE_TIA_IPV6
	int resolv6(char *hostname, struct sockaddr_in6 *saddr6);
#endif

int resolv4(char *hostname, struct sockaddr_in *saddr)
{
	struct hostent *host_data;

	// Try to convert from dotted decimal format
	if((saddr->sin_addr.s_addr = inet_addr(hostname)) != -1) {
		return(0);
	}

	// Query nameserver for hostname
	if((host_data = gethostbyname(hostname)) == NULL) {
		log("Unable to resolve %s to IPv4 address", hostname);
		return(-1);
	}

	// Fill the s_addr field
	memcpy(&saddr->sin_addr.s_addr, host_data->h_addr_list[0], host_data->h_length);
	return(0);
}

#ifdef _HAVE_TIA_IPV6
int resolv6(char *hostname, struct sockaddr_in6 *saddr6)
{
       	struct addrinfo *iaddr = NULL, imatch;
       	char *paddr;

	// Specify IPv6 request
	bzero(&imatch, sizeof(imatch));
	imatch.ai_family = AF_INET6;

	// Get info
        if(getaddrinfo(hostname, NULL, &imatch, &iaddr) == 0) {
                paddr = (char *)malloc(iaddr->ai_addrlen);
                memcpy(paddr, iaddr->ai_addr, iaddr->ai_addrlen);
                freeaddrinfo(iaddr);
		// Fill the sin6_addr field
		memcpy(&saddr6->sin6_addr, &((struct sockaddr_in6 *)paddr)->sin6_addr, (size_t)sizeof(struct in6_addr));
                return(0);
        }

	log("Unable to resolve %s to IPv6 address", hostname);
        return(-1);
}
#endif

/*				resolv.c				*/
