/*				signals.c				*/
/*########################################################################
#                                                                        #
#                            Total IRC Access tunnel                     #
#                    by tHE rECIdjVO <recidjvo@pkcrew.org>               #
#                         http://tiatunnel.pkcrew.org/                   #
#                                                                        #
#   version: 0.9alpha3                                                   #
########################################################################*/

#include <signal.h>
#include "tiatunnel.h"

extern int parse_conf_file(char *conf_file, char verbose);

extern int entries;
extern char conf_file[512];

void setsignals(void);
void resetsignals(void);
void rehash(int signaln);

void setsignals()
{
	// Set signals handlers
	signal(SIGHUP, rehash);
	return;
}

void resetsignals()
{
	// Set signals for children
	signal(SIGHUP, SIG_IGN);
	return;
}

void rehash(int signaln)
{
	// Reparse config file without killing existing connections
	log("Rehashing on SIGHUP");
	entries = parse_conf_file(conf_file, 'n');
	return;
}

/*				signals.c				*/
